""" unittest for op
	to run the unittest you have to set localpath just below
"""
import unittest, os, op, shutil
reload(op)
localpath=r"""d:\dev\Py\modules\OPTest"""

def pn(*args):
	r=localpath
	for a in args:
		r = os.path.join(r, a)
	return r

def pa(*args):
	r=localpath
	for a in args:
		r = os.path.join(r, a)
	return op.path(r)

def kill(p):
	if os.path.isfile(p):
		f = open(p)
		f.close()
		os.remove(p)
	elif os.path.isdir(p):
		f = open(p)
		f.close()
		shutil.rmtree(p)

class Global:
	base=op.path(localpath)
	afile=pa("afile.txt")
	afilesized8=pa("afilesized8.txt")
	adir=pa("adir")
	adirone=pa("adir", "one.txt")
	adirtwo=pa("adir", "two")
	emptydir=pa("emptydir")
	dirwithtwosubdirs=pa("dirwithtwosubdirs")
	cmpdir=pa("cmpdir")
	cmpdirequal=pa("cmpdirequal")
	cmpdirnotequal=pa("cmpdirnotequal")
	cmpfile=pa("cmpfile.txt")
	cmpfileequal=pa("cmpfileequal.txt")
	cmpfilenotequal=pa("cmpfilenotequal.txt")
	adirsized8=pa("adirsized8")
	adirwithsubssized18=pa("adirwithsubssized18")
	searchdir=pa("searchdir")
	#used to read write, dont remove it, but do whatever else
	temp=pa("temp.txt")

g=Global()

class PathTester(unittest.TestCase):
	def setUp(self):
		pass
	def testcreatecompare(self):
		p = op.path("no")
		assert p, 'Not created'
		p = op.path()
		p2 = op.path()
		assert p==p2, 'empty obj, not equal'
		p = op.path("C:\\")
		assert p != p2, 'empty obj and c: is equal'
		p = pa("adirwithsubssized18"+os.sep+"subdir"+os.sep+"file.txt")
		x = op.path(localpath, "adirwithsubssized18", "subdir", "file.txt")
		assert p == x, "op.path should join args to filename"
	def testpath(self):
		assert g.afile.str()==pn("afile.txt"), 'p.str() not working'
		a=g.afile
		assert op.path(op.path(op.path(a.str()))).str()==pn("afile.txt"), 'recursive p.str() not giving same result (e.g. your are using repr in __str__'
		assert g.afile.str()
		assert g.afile.dir() == pn()
	def testIsfileAndisdir(self):
		assert g.afile.isfile(), 'afile.isfile() not working'
		assert not g.afile.isdir(), 'afile.isdir() not working'
		assert not g.adir.isfile(), 'afile.isfile() not working2'
		assert g.adir.isdir(), 'afile.isdir() not working'
	def testlistonlyfiles(self):
		x=g.adir.listonlyfiles()
		o=pa("adir", "one.txt")
		assert o in x, 'afile.listonlyfiles() not working dident find one.txt'
		assert len(x)==1, 'listonlyfiles expected 1 got'+str(len(x))
		x=g.emptydir.listonlyfiles()
		assert len(x)==0, 'emptydir.listonlyfiles() not empty '+str(x)
	def testname(self):
		assert g.afile.namenoext()=="afile", 'afile.namenoext() dident return afile but ' + g.afile.namenoext()
		assert g.afile.name()=="afile.txt", 'afile.namenoext() dident return afile.txt but ' + g.afile.namenoext()
		assert g.afile.ext()==".txt", 'afile.ext() dident return .txt but '+str(g.afile.ext())
	def testsize(self):
		assert g.afile.size() == 0, 'afile.size() dident return 0 but ' + str(g.afile.size())
		assert g.afilesized8.size()==8, 'afilesized8.size() dident return 8 but ' + str(g.afile.size())
	def testlistonlydirs(self):
		x=g.dirwithtwosubdirs.listonlydirs()
		assert len(x)==2, 'dirwithtwosubdirs.listonlydirs() expected len 2 but got'+len(x)
		x=g.emptydir.listonlydirs()
		assert len(x)==0, 'dirwithtwosubdirs.listonlydirs() expected len 0 but got'+len(x)
	def testlist(self):
		x=g.adir.list()
		assert g.adirone in x, "else"
		x.remove(g.adirone)
		assert g.adirtwo in x, "else"
		x.remove(g.adirtwo)
		assert len(x)==0, 'x shold be empty now, but is '+str(len(x))
	def testmakeremovedir(self):
		name=pn('newdir')
		if os.path.isdir(name):
			os.removedirs(name)
		newdir=g.base.makedirs(name)
		assert os.path.isdir(name), "diden't create new dir"
		newdir.remove()
		assert not os.path.isdir(name), "diden't remove new dir"
	def testmakeremovesubdir(self):
		name=pn('newdir', 'subdir')
		if os.path.isdir(name):
			os.removedirs(name)
		newdir=g.base.makedirs(name)
		assert os.path.isdir(name), "diden't create new dir"
		newdir.remove()
		assert not os.path.isdir(name), "diden't remove new dir"
	def testcmpfile(self):
		# user should select basen on property or contents
		assert g.cmpfile.cmp(g.cmpfileequal), 'cmp() should be equal'
		assert not g.cmpfile.cmp(g.cmpfilenotequal), 'cmp() should not be equal'
	def testcmpdir(self):
		# user should select basen on property or contents
		assert g.cmpdir.cmp(g.cmpdirequal), 'cmp() should be equal'
		assert not g.cmpdir.cmp(g.cmpdirnotequal), 'cmp() should not be equal'
	def testcopydir(self):
		try:
			n="testcopydir"
			tmp=pn(n)
			if os.path.isdir(tmp):
				shutil.rmtree(tmp)
			todir=tmp.makedirs(n)
			g.cmpdir.copy(todir)
			assert g.cmp(todir), 'copy dir dident mach cmpdir with'+str(to)
		except:
			tmp=pn(n)
			if os.path.isdir(tmp):
				shutil.rmtree(tmp)
	def testreallines(self):
		a=g.afilesized8.readlines()
		assert len(a)==2, 'afilessized8 not two lines by readlines()'
		assert a[0]=="12\n", 'afilessized8 not 12\\n'
		assert a[1]=="1234", 'afilessized8 not 1234'
	def testreadlineswithopenfile(self):
		f=open(g.afilesized8.str())
		try:
			a=g.afilesized8.readlines()
		except:
			f.close()
			assert 0, 'exception when readlines on open file'
	def testreadlinesondir(self):
		#this should return a better error "cannot readline() on a dir()"
		a=g.adir
		try:
			a.readlines()
			assert 1, 'expected exception when readline from a dir'
		except:
			pass
	def testreadwrite(self):
		t = g.temp
		t.empty()
		t.writelines(g.afilesized8.readlines())
		assert t.cmp(g.afilesized8), 'readlines error, temp file != org file'
		t.empty()
		t.write(g.afilesized8.read())
		assert t.cmp(g.afilesized8), 'read error, temp file != org file'
	def testsizeofdir(self):
		assert g.adirsized8.size()==8, 'adirsized8 size not 8 but '+str(g.adirsized8.size())
		assert g.adirwithsubssized18.size()==18, 'adirwithsubssized18 size() not 18 but '+str(g.adirwithsubssized18.size())
	def testnewtempfiles(self):
		pass
	def testempty(self):
		t = g.temp
		t.write("hello")
		t.empty()
		assert t.size()==0, 'empty dident empty'
	def testlistall(self):
		t = g.adirwithsubssized18
		l = t.listall()
		assert len(l)==3, 'listall expected 3 files, one in subdir'
		assert pa("adirwithsubssized18", "subdir", "file.txt") in l, 'listall expected file.txt in subdir'
	def teststringcompat(self):
		t = g.afile
		a = t.replace(".txt", ".doc")
		b = pn("afile.doc")
		assert a == b, "string compatability not working"
	def testlistconctraint(self):
		#find how to emulate windows searching re are overkill
		#if you use a * then translate to re"start whatever .* endline"
		d = g.searchdir
		all = ["file.py", "file.txt", "file1.py", "py.py", "py.py.txt"]
		searched = ["file.py", "file1.py", "py.py"]

		sall = d.list("*")
		assert len(sall)==len(all), "expected same size got sall:"+str(len(sall))
		for x in all:
			f = os.path.join(g.searchdir.str(), x)
			assert f in sall, "Expected to find:"+f+" in "+str(sall)
		
		sall = d.list("*.py")
		assert len(sall)==len(searched), "expected size:"+str(len(searched))+" got:"+str(len(sall))
		for x in searched:
			f = os.path.join(g.searchdir.str(), x)
			assert f in sall, "Expected to find:"+f+" in "+str(sall)

		sall = d.listall("*.py")
		assert len(sall)==len(searched), "expected size:"+str(len(searched))+" got:"+str(len(sall))
		for x in searched:
			f = os.path.join(g.searchdir.str(), x)
			assert f in sall, "Expected to find:"+f+" in "+str(sall)
	def testprintto(self):
		t = g.temp
		t.empty()
		print >> t, "one"
		assert t.readlines()==["one\n"], "printto not working"
		print >> t, "two"
		assert t.readlines()==["one\n", "two\n"], "print to two times not working"


suite = unittest.makeSuite(PathTester, 'test')

if __name__ == "__main__":
	unittest.TextTestRunner().run(suite)

#r = profile.run("unittest.TextTestRunner().run(suite)")